import vl from 'vega-lite-api';
const hover = vl.selectSingle()
    .encodings('x')  // limit selection to x-axis value
    .on('mouseover') // select on mouseover events
    .nearest(true)   // select data point nearest the cursor
    .empty('none')
    .clear("mouseout");

const area = vl.markArea()
    .encode(
      vl
      .y()
      .fieldQ('Runs')
      .title('---- Runs ----'),

    vl
      .x()
      .fieldT('Year')
      .scale({ nice: false })
      .title('---- Year ----'));

const circle=
      vl.markCircle()
  .encode(
    vl
      .y()
      .fieldQ('Runs'),
    
    vl
      .x()
      .fieldT('Year')
      .scale({ nice: false })
      .title('---- Year ----'));

const base = area.transform(vl.filter(hover));
const label = {align: 'left', dx: 5, dy: -5};
const white = {stroke: '#CD5C5C', strokeWidth: 15};

export const viz =
  vl.layer(circle,
    area,
    area.markCircle()
        .select(hover) // use as anchor points for selection
        .encode(vl.opacity().if(hover, vl.value(1)).value(0)),
    vl.markRule({color: '#FF0000'})
        .transform(vl.filter(hover))
        .encode(vl.x().fieldT('Year')),
    base.markText(label, white).encode(vl.text().fieldQ('Runs')),
    base.markText(label).encode(vl.text().fieldQ('Runs')));
console.log('test')